---
title: FileReader.readAsArrayBuffer()
slug: Web/API/FileReader/readAsArrayBuffer
tags:
  - API
  - DOM
  - File API
  - FileReader
  - Files
  - Method
  - Reference
  - readAsArrayBuffer
---
<p>{{APIRef("File API")}}</p>

<p>The {{domxref("FileReader")}} interface's <strong><code>readAsArrayBuffer()</code></strong> method is used to start reading the contents of a specified {{domxref("Blob")}} or {{domxref("File")}}. When the read operation is finished, the {{domxref("FileReader.readyState","readyState")}} becomes <code>DONE</code>, and the {{domxref("FileReader/loadend_event", "loadend")}} is triggered. At that time, the {{domxref("FileReader.result","result")}} attribute contains an {{domxref("ArrayBuffer")}} representing the file's data.</p>

<div class="notecard note">
<p><strong>Newer API available</strong><br>
 The {{domxref("Blob.arrayBuffer()")}} method is a newer promise-based API to read a file as an array buffer.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>instanceOfFileReader</var>.readAsArrayBuffer(<var>blob</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>blob</var></code></dt>
 <dd>The {{domxref("Blob")}} or {{domxref("File")}} from which to read.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("File API", "#readAsArrayBuffer", "FileReader.readAsArrayBuffer")}}</td>
   <td>{{Spec2("File API")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileReader.readAsArrayBuffer")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("FileReader")}}</li>
</ul>
